package at.ac.uibk.gitsearch.service;


import java.io.IOException;
import java.util.Optional;

import org.codeability.sharing.plugins.api.search.SearchResultDTO;
import org.codeability.sharing.plugins.api.search.SearchResultsDTO;

import org.springframework.transaction.annotation.Transactional;


import at.ac.uibk.gitsearch.service.SearchService;
import at.ac.uibk.gitsearch.service.StatisticsService;
import at.ac.uibk.gitsearch.service.UserService;
import at.ac.uibk.gitsearch.service.dto.StatisticsDTO;
import org.springframework.stereotype.Service;

@Service
@Transactional
public class AchievementService {
    
	
    private final SearchService searchService;

    private final StatisticsService statisticsService;

    private final UserService userService;


    public AchievementService(SearchService searchService, StatisticsService statisticsService, UserService userService) {
        this.searchService = searchService;
        this.statisticsService = statisticsService;
        this.userService = userService;
    }

 
    public StatisticsDTO searchUserStatistics(String email) throws IOException {
  
        SearchResultsDTO results = searchService.searchResultForAuthorEmail(email, 1000);
        int totalAmountOfViews = 0;
        int totalAmountOfDownloads = 0;
        for (SearchResultDTO result : results.getSearchResult()) {
            Optional<StatisticsDTO> statisticsDTO = statisticsService.findOneByExerciseID((Long.parseLong(result.getExerciseId())));
            if (statisticsDTO.isPresent()) {
                StatisticsDTO newStats = statisticsDTO.get();
                totalAmountOfViews += newStats.getViews();
                totalAmountOfDownloads += newStats.getDownloads();
            }
        }
        StatisticsDTO toReturn = new StatisticsDTO();
        toReturn.setViews(totalAmountOfViews);
        toReturn.setDownloads(totalAmountOfDownloads);
        return toReturn;
    
    
    }

}
